#!/bin/sh

# Written in 2023 by Márcio Silva <coadde@hyperbola.info>
#
# To the extent possible under law, the author(s) have dedicated all copyright
# and related and neighboring rights to this software to the public domain
# worldwide. This software is distributed without any warranty.
#
# You should have received a copy of the CC0 Public Domain Dedication along
# with this software. If not, see
# <https://creativecommons.org/publicdomain/zero/1.0/>.


# () subshell, this convert variables to local scope

# HyperbolaBSD:
#
# kernel:      description:
# bsd          GENERIC.MP
# bsd.sp       GENERIC
# bsd.odd      RAMDISK_CD (compressed with gzip)
# bsd.rd       RAMDISK (compressed with gzip)
#
# user:        password:
# root         hyperbolabsd
# hyperbolabsd hyperbolabsd

# OpenBSD:
#
# user:        password:
# root         openbsd
# openbsd      openbsd


function \
args_f()
{(
    ARGS='
        -machine q35
        -cpu host
        -smp 2
        -m 4G
        -device intel-hda
        -device hda-duplex
        -name HyperbolaBSD
    '

    [ $1 ] && ARGS+=' -hda '$1
    [ $2 ] && ARGS+=' -hdb '$2
    [ $3 ] && ARGS+=' -hdc '$3

    ARGS+='
        -enable-kvm
        -netdev user,id=mynet0,hostfwd=tcp:127.0.0.1:7922-:22
        -device virtio-net,netdev=mynet0
    '

    printf '%s\n' $ARGS
)}


(
    #ARGS+=' obsd_v7d0.img'
    ARGS+=' hbbsd_v0d99pa_debug.img'
    ARGS+=' bsd_ext2.img'

    qemu-system-x86_64 $(args_f $ARGS)
)
